package de.ivu.elect.presentation.benutzerverwaltung.table;

import java.util.ArrayList;
import java.util.List;

import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.benutzerverwaltung.boundary.BenutzerEinsatzortExtendedDAO;
import de.ivu.elect.business.benutzerverwaltung.entity.BenutzerEinsatzort;
import de.ivu.elect.business.benutzerverwaltung.entity.BenutzerEinsatzortMeta;
import de.ivu.elect.business.benutzerverwaltung.entity.Rolle;
import de.ivu.elect.business.benutzerverwaltung.entity.RolleConstants;
import de.ivu.elect.jee.presentation.dynamictable.AbstractColumnBuilder;
import de.ivu.elect.jee.presentation.dynamictable.ColumnEntry;
import de.ivu.elect.jee.presentation.dynamictable.ColumnType;


import static java.util.stream.Collectors.toList;

@Named(BenutzerEinsatzortColumnBuilder.COMPONENT_NAME)
public class BenutzerEinsatzortColumnBuilder extends AbstractColumnBuilder<BenutzerEinsatzort> {

  public static final String COMPONENT_NAME = "benutzerEinsatzortColumnBuilder";

  private static final long serialVersionUID = 1L;

  @Inject
  BenutzerEinsatzortExtendedDAO benutzerEinsatzortExtendedDAO;

  AbstractBenutzerEinsatzortColumn<BenutzerEinsatzort> benutzerEinsatzortNameColumn;

  AbstractBenutzerEinsatzortColumn<BenutzerEinsatzort> benutzerEinsatzortBemerkungColumn;

  AbstractBenutzerEinsatzortColumn<BenutzerEinsatzort> benutzerEinsatzortClientIpMusterColumn;

  AbstractBenutzerEinsatzortColumn<BenutzerEinsatzort> rollenColumn;
    AbstractBenutzerEinsatzortColumn<BenutzerEinsatzort> benutzerEinsatzortBesonderheitColumn;

  @Inject
  private BenutzerEinsatzortMeta benutzerMeta;

  @Override
  protected void initColumns() {
    benutzerEinsatzortNameColumn = AbstractBenutzerEinsatzortColumn
        .createBenutzerEinsatzortNameColumn(getMessages());
    benutzerEinsatzortBemerkungColumn = AbstractBenutzerEinsatzortColumn
        .createBenutzerEinsatzortBemerkungColumn(getMessages());
    benutzerEinsatzortClientIpMusterColumn = AbstractBenutzerEinsatzortColumn
        .createBenutzerEinsatzortClientIpMusterColumn(getMessages());
    benutzerEinsatzortBesonderheitColumn = AbstractBenutzerEinsatzortColumn
        .createBenutzerEinsatzortBesonderheitColumn(getMessages());

    rollenColumn = new AbstractBenutzerEinsatzortColumn<>(
        "BenutzerEinsatzortColumnBuilder-rollen", getMessages(), RolleConstants.MESSAGE_KEY_ENTITY_MEHRZAHL, ColumnType.COLLECTION,
        benutzerEinsatzort -> benutzerEinsatzortExtendedDAO.attach(benutzerEinsatzort).getRolles().stream().map(Rolle::getName).sorted().collect(toList()));
  }

  @Override
  protected List<ColumnEntry<? super BenutzerEinsatzort>> getColumnEntriesSorted() {
    List<ColumnEntry<? super BenutzerEinsatzort>> result = new ArrayList<>();

    result.add(benutzerEinsatzortNameColumn);
    result.add(benutzerEinsatzortBemerkungColumn);
    result.add(benutzerEinsatzortClientIpMusterColumn);
    addBesonderheitColumn(result);
    result.add(rollenColumn);

    return result;
  }

  protected void addBesonderheitColumn(List<ColumnEntry<? super BenutzerEinsatzort>> result) {
    result.add(benutzerEinsatzortBesonderheitColumn);
  }
}
